#ifndef CV_INPUT_H
#define CV_INPUT_H 1

#include <stdint.h>

#define CV_FIRE_0 0x40
#define CV_FIRE_1 0x80
#define CV_FIRE_2 0x10
#define CV_FIRE_3 0x20
#define CV_LEFT 0x08
#define CV_DOWN 0x04
#define CV_RIGHT 0x02
#define CV_UP 0x01

struct cv_controller_state
{
	uint8_t keypad;	// Keypad: 0 - 9 as on keypad, * as 0xa, # as 0xb, 0xf for no key pressed or error.
	uint8_t joystick;// Joystick: lowest 4 bit for joystick, higher 4 bit for fire buttons.	
	int16_t spinner;
};

// Set spinner value
void cv_set_controller_state(const struct cv_controller_state *state, uint8_t controller);

// Get keypad, joystick and spinner values
void cv_get_controller_state(struct cv_controller_state *state, uint8_t controller);

#endif
